	-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib
local t,s
if cfg.release>6 then
lib.classes["HUNTER"] = {}
lib.classpreload["HUNTER"] = function()
	lib.SetPower("FOCUS")
	lib.AddResourceBar(cfg.Power.max)
	lib.ChangeResourceBarType(cfg.Power.type)
end
	
	
lib.classes["HUNTER"][10] = function () -- BM
	cfg.talents={
		["Steady_Focus"]=IsPlayerSpell(177667),
		["Focusing_Shot"]=IsPlayerSpell(152245)
	}
	lib.AddSpell("FF",{82692},true) -- Focus Fire
	--lib.AddAura("FF",82692,"buff","player") -- Focus Fire
	lib.AddSpell("KC",{34026}) -- Kill Command
	lib.AddSpell("KS",{53351}) -- Kill Shot
	lib.AddAura("FF_stacks",19615,"buff","player","pet") -- Frenzy
	lib.AddResourceCombo(5,nil,nil,"other")
	lib.UpdateResourceCombo(lib.GetAuraStacks("FF_stacks"))
	lib.SetAuraFunction("FF_stacks","OnStacks",function() lib.UpdateResourceCombo(lib.GetAuraStacks("FF_stacks")) end)
	lib.AddSpell("BW",{19574},true) -- Bestial Wrath
	--lib.AddAura("BW",19574,"buff","player") -- Bestial Wrath
	lib.AddAura("BC",118455,"buff","pet") -- Beast Cleave
	lib.SetTrackAura("BC")
	lib.SetAuraFunction("BC","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["pet"],0)
	end)
	lib.SetAuraFunction("BC","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["pet"])
	end)
	lib.AddAura("SF",177668,"buff","player") -- Steady Focus
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"Tranq")
	table.insert(cfg.plistdps,"Mend_pet")
	table.insert(cfg.plistdps,"MD_noMD")
	table.insert(cfg.plistdps,"Stampede_buff")
	table.insert(cfg.plistdps,"DB")
	table.insert(cfg.plistdps,"FF_noFF")
	table.insert(cfg.plistdps,"BW_30")
	table.insert(cfg.plistdps,"FF_FF5")
	table.insert(cfg.plistdps,"KC")
	table.insert(cfg.plistdps,"KS")
	if cfg.talents["Steady_Focus"] and not cfg.talents["Focusing_Shot"] then
		table.insert(cfg.plistdps,"Shot2_SF")
	end
	table.insert(cfg.plistdps,"Barrage")
	table.insert(cfg.plistdps,"Crows")
	table.insert(cfg.plistdps,"AS_thrill")
	table.insert(cfg.plistdps,"AS_focus")
	table.insert(cfg.plistdps,"Shot")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"CS")
	table.insert(cfg.plistaoe,"Tranq")
	table.insert(cfg.plistaoe,"Mend_pet")
	table.insert(cfg.plistaoe,"MD_noMD")
	table.insert(cfg.plistaoe,"FF_aoe")
	table.insert(cfg.plistaoe,"BW")
	table.insert(cfg.plistaoe,"MS_BC")
	table.insert(cfg.plistaoe,"Barrage")
	table.insert(cfg.plistaoe,"DB")
	if cfg.talents["Steady_Focus"] and not cfg.talents["Focusing_Shot"] then
		table.insert(cfg.plistaoe,"Shot2_SF")
	end
	table.insert(cfg.plistaoe,"KC_aoe")
	table.insert(cfg.plistaoe,"KS")
	table.insert(cfg.plistaoe,"ET")
	table.insert(cfg.plistaoe,"MS_thrill")
	table.insert(cfg.plistaoe,"MS_focus")
	table.insert(cfg.plistaoe,"Shot")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps
	
	cfg.case = {}
	cfg.case = {
		["MS_BC"] = function()
			if lib.IsLastSpell("MS") then return nil end
			return lib.SimpleCDCheck("MS",lib.GetAura({"BC"}))
		end,
		["FF_FF5"] = function()
			if lib.GetAuraStacks("FF_stacks")>=5 then return lib.SimpleCDCheck("FF",lib.GetAura({"FF"}),true) end
			return nil
		end,
		["FF_noFF"] = function()
			if lib.GetAuraStacks("FF_stacks")>0 then
				if lib.GetSpellCD("BW")<=lib.GetAura({"FF"})+1.5 or lib.GetSpellCD("Stampede")>=lib.GetAura({"FF"})+260 or lib.GetAura({"BW"})>=lib.GetAura({"FF"})+3 then
					return lib.SimpleCDCheck("FF",lib.GetAura({"FF"}),true)
				end
				if lib.KnownSpell("Stampede") and lib.GetSpellCD("Stampede")<lib.GetAura({"FF"}) then
					return lib.SimpleCDCheck("FF",lib.GetAura({"FF"}),true)
				end
			end
			return nil
		end,
		["FF_aoe"] = function()
			if lib.GetAuraStacks("FF_stacks")>0 then
				return lib.SimpleCDCheck("FF",lib.GetAura({"FF"}),true)
			end
		end,
		["BW_30"] = function()
			return lib.SimpleCDCheck("BW",hedlib.GetMax({lib.Time2Power(30),lib.GetAura({"BW"})}))
		end,
		["AS_focus"] = function()
			return lib.SimpleCDCheck("AS",lib.Time2Power(75))
		end,
		["MS_focus"] = function()
			return lib.SimpleCDCheck("MS",lib.Time2Power(75))
		end,
		["KC_aoe"] = function()
			if lib.GetAura({"BW"})>lib.GetSpellCD("KC") then
				return lib.SimpleCDCheck("KC",lib.Time2Power(30))
			else
				return lib.SimpleCDCheck("KC",lib.Time2Power(60))
			end
		end,
		["AS_thrill"] = function()
			if (lib.GetAura({"Thrill"}) > lib.GetSpellCD("AS")) then
				return lib.SimpleCDCheck("AS",lib.Time2Power(35))
			end
			if lib.GetAura({"BW"}) > lib.GetSpellCD("AS") then
				return lib.SimpleCDCheck("AS")
			end
			return nil
		end,
		["MS_thrill"] = function()
			if lib.GetAura({"Thrill"}) > lib.GetSpellCD("MS") then
				return lib.SimpleCDCheck("MS",lib.Time2Power(35))
			end
			if lib.GetAura({"BW"}) > lib.GetSpellCD("MS") then
				return lib.SimpleCDCheck("MS")
			end
			return nil
		end,
		
	}
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end
--	cfg.spells_aoe={"MS"}
	cfg.spells_single={"AS"}
	return true
end

lib.classes["HUNTER"][2] = function () --MM
	cfg.talents={
		["Sidewinders"]=IsPlayerSpell(214579),
		["Patient Sniper"]=IsPlayerSpell(213423),
		["Careful Aim"]=IsPlayerSpell(53238),
		["Steady Focus"]=IsPlayerSpell(193533),
		["Sentinel"]=IsPlayerSpell(206817),
		["Barrage"]=IsPlayerSpell(120360),
		["True Aim"]=IsPlayerSpell(199527),
	}
	if cfg.talents["Sidewinders"] then
		lib.AddSpell("Sidewinders",{214579})
		lib.SetSpellCost("Sidewinders",-50,"power")
	else
		lib.AddSpell("Arcane Shot",{185358})
		lib.SetSpellCost("Arcane Shot",-5,"power")
		lib.AddSpell("Multi-Shot",{2643})
		lib.SetSpellCost("Multi-Shot",-2,"power")
	end
	lib.AddSpell("A Murder of Crows",{131894},"target")
	lib.AddSpell("Black Arrow",{194599},"target")
	lib.AddSpell("Sentinel",{206817})
	lib.AddSpell("Piercing Shot",{198670})
	lib.AddSpell("Explosive Shot",{212431})
	lib.AddSpell("Windburst",{204147})
	lib.AddSpell("Aimed Shot",{19434})
	lib.AddSpell("Barrage",{120360},nil,nil,true)
	lib.AddSpell("Marked Shot",{185901})
	lib.AddSpell("Trueshot",{193526},true)
	lib.AddAura("Marking Targets",223138,"buff","player")
	lib.AddAura("Steady Focus",193534,"buff","player")
	lib.AddAura("Hunter's Mark",185365,"debuff","target")
	lib.AddAura("True Aim",199803,"debuff","target")
	lib.AddAura("Lock and Load",194594,"buff","player")
	lib.SetAuraFunction("Lock and Load","OnApply",function() lib.ReloadSpell("Aimed Shot") end)
	lib.SetAuraFunction("Lock and Load","OnFade",function() lib.ReloadSpell("Aimed Shot") end)
	
	lib.AddAura("Vulnerable",187131,"debuff","target") --198925
	--[[lib.SetTrackAura("Lock and Load")
	lib.SetAuraFunction("Lock and Load","OnStacks",function()
		lib.UpdateTrackAura(cfg.GUID["player"],lib.GetAuraStacks("Lock and Load")>0 and lib.GetAuraStacks("Lock and Load") or nil)
	end)]]
	lib.SetTrackAura("Vulnerable")
	lib.SetAuraFunction("Vulnerable","OnStacks",function()
		lib.UpdateTrackAura(cfg.GUID["target"],lib.GetAuraStacks("Vulnerable")>0 and lib.GetAuraStacks("Vulnerable") or nil)
	end)

	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Trueshot")
	if cfg.talents["Sentinel"] then --not cfg.talents["Sidewinders"] and
		table.insert(cfg.plistdps,"Marked Shot_Sentinel")
		table.insert(cfg.plistdps,"Sentinel")
	end
	
	table.insert(cfg.plistdps,"Windburst")
	if not cfg.talents["Sidewinders"] and cfg.talents["True Aim"] then
		table.insert(cfg.plistdps,"Arcane Shot_TA")
	end
	if cfg.talents["Patient Sniper"] then
		table.insert(cfg.plistdps,"Marked Shot_PS")
	else
		table.insert(cfg.plistdps,"Marked Shot")
	end
	if not cfg.talents["Sidewinders"] and cfg.talents["Steady Focus"] then
		table.insert(cfg.plistdps,"Arcane Shot_SF")
	end
	if cfg.talents["Careful Aim"] then
		table.insert(cfg.plistdps,"Aimed Shot_CA")
	end
	if cfg.talents["Patient Sniper"] then
		table.insert(cfg.plistdps,"Aimed Shot_PS")
		if cfg.talents["Sidewinders"] then
			table.insert(cfg.plistdps,"Sidewinders_PS")
		end
	end
	table.insert(cfg.plistdps,"Aimed Shot_Lock and Load")
	table.insert(cfg.plistdps,"A Murder of Crows")
	table.insert(cfg.plistdps,"Barrage")
	--if not cfg.talents["Patient Sniper"] then
		if cfg.talents["Sidewinders"] then
			if not cfg.talents["Patient Sniper"] then
				table.insert(cfg.plistdps,"Sidewinders_marked")
			end
		else
			table.insert(cfg.plistdps,"Arcane Shot_marked")
		end
	--end
	table.insert(cfg.plistdps,"Piercing Shot")
	table.insert(cfg.plistdps,"Explosive Shot")
	table.insert(cfg.plistdps,"Black Arrow")
	if cfg.talents["Barrage"] then
		table.insert(cfg.plistdps,"Aimed Shot_60")
	else
		table.insert(cfg.plistdps,"Aimed Shot")
	end
	table.insert(cfg.plistdps,"Marked Shot")
	if cfg.talents["Sidewinders"] then
		--if not cfg.talents["Patient Sniper"] then
			table.insert(cfg.plistdps,"Sidewinders")
		--end
	else
		table.insert(cfg.plistdps,"Arcane Shot")
	end
	table.insert(cfg.plistdps,"end")
		
	cfg.plistaoe = nil
	lib.hunter_CA = function()
		if cfg.talents["Careful Aim"] then
			if lib.GetUnitHealth("target","percent")<80 then return false end
			if cfg.Cleaving>1 and not cfg.noaoe then return false end
			return true
		else
			return false
		end
	end
	
	lib.hunter_AI_Vulnerable = function()
		if lib.GetSpellCD("Aimed Shot")+lib.GetSpellCT("Aimed Shot")<lib.GetAura({"Vulnerable"}) then
			return true
		else
			return false
		end
	end
	cfg.plist = cfg.plistdps
	cfg.case = {}
	cfg.case = {
		--CA
		["Windburst_CA"] = function()
			if lib.hunter_CA() then
				return lib.SimpleCDCheck("Windburst")
			end
			return nil
		end,
		["Arcane Shot_SF"] = function()
			if lib.IsLastSpell("Arcane Shot") then
				return lib.SimpleCDCheck("Arcane Shot",lib.GetAura({"Steady Focus"}))
			end
			return nil
		end,
		["Arcane Shot_CA_TA"] = function()
			if lib.hunter_CA() then
				if lib.IsLastSpell("Aimed Shot") or lib.SpellCasting("Aimed Shot") then
					if lib.GetAuraStacks("True Aim")<8 then
						return lib.SimpleCDCheck("Arcane Shot")
					else
						return lib.SimpleCDCheck("Arcane Shot",lib.GetAura({"True Aim"})-2)
					end
				end
			end
			return nil
		end,
		["Arcane Shot_TA"] = function()
			if lib.IsLastSpell("Aimed Shot") or lib.SpellCasting("Aimed Shot") then
				if lib.GetAuraStacks("True Aim")<8 then
					return lib.SimpleCDCheck("Arcane Shot")
				else
					return lib.SimpleCDCheck("Arcane Shot",lib.GetAura({"True Aim"})-2)
				end
			end
			return nil
		end,
		["Marked Shot_CA"] = function()
			if lib.IsLastSpell("Marked Shot") then return nil end
			if lib.GetAura({"Hunter's Mark"})>lib.GetSpellCD("Marked Shot") then
				if cfg.talents["Sidewinders"] then
					if cfg.talents["Patient Sniper"] then
						if not lib.hunter_AI_Vulnerable() then
							return lib.SimpleCDCheck("Marked Shot")
						end
					else
						return lib.SimpleCDCheck("Marked Shot")
					end
				else
					return lib.SimpleCDCheck("Marked Shot")
				end
			end
			return nil
		end,	
--[[	["Marked Shot"] = function()
			if lib.IsLastSpell("Marked Shot") then return nil end
			if lib.GetAura({"Hunter's Mark"})>lib.GetSpellCD("Marked Shot") then
				if cfg.talents["Sidewinders"] then
					if cfg.talents["Patient Sniper"] then
						return lib.SimpleCDCheck("Marked Shot",lib.GetAura({"Vulnerable"})-2)
					else
						return lib.SimpleCDCheck("Marked Shot")
					end
				else
					return lib.SimpleCDCheck("Marked Shot")
				end
				return lib.SimpleCDCheck("Marked Shot",lib.GetAura({"Hunter's Mark"})-cfg.gcd)
			end
			return nil
		end,]]--
		["Marked Shot_PS"] = function()
			if lib.IsLastSpell("Marked Shot") then return nil end
			return lib.SimpleCDCheck("Marked Shot",lib.GetAura({"Vulnerable"})-2)
		end,
		["Marked Shot"] = function()
			if lib.IsLastSpell("Marked Shot") then return nil end
			return lib.SimpleCDCheck("Marked Shot")
		end,
		["Marked Shot_Sentinel"] = function()
			if lib.IsLastSpell("Marked Shot") then return nil end
			if not lib.IsLastSpell("Sentinel") then return nil end
			if lib.GetAura({"Hunter's Mark"})>lib.GetSpellCD("Marked Shot") then
				return lib.SimpleCDCheck("Marked Shot")
			end
			return nil
		end,
		["Sidewinders_marked"] = function()
			if lib.GetAura({"Marking Targets"})>lib.GetSpellCD("Sidewinders") then
				return lib.SimpleCDCheck("Sidewinders",lib.GetAura({"Hunter's Mark"}))
			end
			return nil
		end,
		["Sidewinders_PS"] = function()
			if cfg.Power.max==cfg.Power.now then return nil end
			--[[if lib.Time2Power(lib.GetSpellCost("Aimed Shot"))>lib.GetAura({"Vulnerable"}) then
				return lib.SimpleCDCheck("Sidewinders")
			end]]
			return lib.SimpleCDCheck("Sidewinders",lib.GetAura({"Vulnerable"}))
		end,
		["Sentinel"] = function()
			return lib.SimpleCDCheck("Sentinel",lib.GetAura({"Marking Targets","Hunter's Mark"},"max"))
		end,
		["Arcane Shot_marked"] = function()
			if lib.GetAura({"Marking Targets"})>lib.GetSpellCD("Arcane Shot") then
				return lib.SimpleCDCheck("Arcane Shot",lib.GetAura({"Hunter's Mark"}))
			end
			return nil
		end,
		["Aimed Shot_Lock and Load"] = function()
			if lib.GetAura({"Lock and Load"})>lib.GetSpellCD("Aimed Shot") then
				return lib.SimpleCDCheck("Aimed Shot")
			end
			return nil
		end,
		
		["Aimed Shot_CA"] = function()
			if lib.GetUnitHealth("target","percent")>=80 then
				return lib.SimpleCDCheck("Aimed Shot")
			end
			return nil
		end,
		["Aimed Shot_PS"] = function()
			if lib.GetSpellCD("Aimed Shot")+lib.GetSpellCT("Aimed Shot")<lib.GetAura({"Vulnerable"}) then
				return lib.SimpleCDCheck("Aimed Shot")
			end
			return nil
		end,
		
		["Aimed Shot_60"] = function()
			return lib.SimpleCDCheck("Aimed Shot",lib.Time2Power(60))
		end,
		
		["MS_focus"] = function()
			return lib.SimpleCDCheck("MS",lib.Time2Power(lib.GetSpellCost("MS")+lib.GetSpellCost("Chimera")))
		end,
		["AI_80"] = function()
			if lib.GetUnitHealth("target","percent")>80 or lib.GetAura({"RF"}) > lib.GetSpellCD("AI")+lib.GetSpellCT("AI") then
				if lib.GetAuraStacks("Thrill")==1 and lib.SpellCasting("AI") then
					return lib.SimpleCDCheck("AI",lib.Time2Power(50))
				else
					return lib.SimpleCDCheck("AI")
				end
			end
			return nil
		end,
		["Shot_80"] = function()
			if lib.GetUnitHealth("target","percent")>80 or lib.GetAura({"RF"}) > 0 then
				if lib.KnownSpell("FS") then return lib.SimpleCDCheck("FS") end
				return lib.SimpleCDCheck("Shot")
			end
			return nil
		end,
		["AI_focus"] = function()
			if lib.KnownSpell("FS") then
				return lib.SimpleCDCheck("AI")
			end
			if lib.GetAuraStacks("Thrill")==1 and lib.SpellCasting("AI") then
				return lib.SimpleCDCheck("AI",lib.Time2Power(50+lib.GetSpellCost("Chimera")))
			else
				return lib.SimpleCDCheck("AI",lib.Time2Power(lib.GetSpellCost("AI")+lib.GetSpellCost("Chimera")))
			end
		end,
		
		["AI_thrill"] = function()
			if lib.GetAura({"Thrill"})>lib.GetSpellCD("AI")+lib.GetSpellCT("AI") then
				if lib.GetAuraStacks("Thrill")==1 and lib.SpellCasting("AI") then
					return nil
				end
				return lib.SimpleCDCheck("AI")
			end
			return nil
		end,
	}

	cfg.mode = "dps"
	
	--cfg.spells_aoe={"ET","MS"}
	--cfg.spells_single={"AI"}
	return true
end

lib.classes["HUNTER"][3] = function () -- Surv
	cfg.talents={
		--["Steady_Focus"]=IsPlayerSpell(177667),
		["Way of the Mok'Nathal"]=IsPlayerSpell(201082),
		["Serpent Sting"]=IsPlayerSpell(87935),
		["Butchery"]=IsPlayerSpell(212436),
	}

	lib.AddSpell("Explosive Trap",{191433})
	lib.AddAura("Explosive Trap",13812,"debuff","target")
	lib.AddSpell("Dragonsfire Grenade",{194855})
	lib.AddAura("Dragonsfire Grenade",194858,"debuff","target")
	lib.AddSpell("Mongoose Bite",{190928})
	lib.AddAura("Mongoose Fury",190931,"buff","player")
	lib.SetTrackAura("Mongoose Fury")
	lib.SetAuraFunction("Mongoose Fury","OnStacks",function()
		lib.UpdateTrackAura(cfg.GUID["player"],lib.GetAuraStacks("Mongoose Fury")>0 and lib.GetAuraStacks("Mongoose Fury") or nil)
	end)
	lib.AddSpell("Flanking Strike",{202800})
	lib.AddSpell("Raptor Strike",{186270})
	lib.AddAura("Serpent Sting",118253,"debuff","target")
	lib.AddAura("Mok'Nathal Tactics",201081,"buff","player")
	lib.AddAura("Raptor Strike",201081,"buff","player")
	lib.AddSpell("Fury of the Eagle",{203415})
	lib.AddSpell("Steel Trap",{162488})
	lib.AddAura("Steel Trap",162487,"debuff","target")
	lib.AddSpell("Throwing Axes",{200163})
	lib.AddSpell("Snake Hunter",{201078})
	lib.AddSpell("Hatchet Toss",{193265})
	lib.AddSpell("Harpoon",{190925})
	lib.AddSpell("Caltrops",{194277})
	lib.AddAura("Caltrops",194279,"debuff","target")
	lib.AddSpell("Lacerate",{185855},"target")
	lib.AddSpell("A Murder of Crows",{206505},"target")
	lib.AddSpell("Spitting Cobra",{194407},true)
	lib.AddSpell("Aspect of the Eagle",{186289},true)
	if cfg.talents["Butchery"] then
		lib.AddSpell("Butchery",{212436})
	else
		lib.AddSpell("Carve",{187708})
	end
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Harpoon")
	table.insert(cfg.plistdps,"Hatchet Toss")
	if cfg.talents["Way of the Mok'Nathal"] then
		table.insert(cfg.plistdps,"Raptor Strike_buff")
	end
	table.insert(cfg.plistdps,"Mongoose Bite_Mongoose Fury")
	table.insert(cfg.plistdps,"Aspect of the Eagle")
	table.insert(cfg.plistdps,"Snake Hunter")
	
	table.insert(cfg.plistdps,"Explosive Trap")
	table.insert(cfg.plistdps,"Dragonsfire Grenade")
	--table.insert(cfg.plistdps,"Aspect of the Eagle")
	table.insert(cfg.plistdps,"Fury of the Eagle")
	table.insert(cfg.plistdps,"Mongoose Bite_max")
	table.insert(cfg.plistdps,"Steel Trap")
	table.insert(cfg.plistdps,"A Murder of Crows")
	table.insert(cfg.plistdps,"Lacerate")
	if cfg.talents["Serpent Sting"] then
		table.insert(cfg.plistdps,"Raptor Strike_debuff")
	end
	
	table.insert(cfg.plistdps,"Butchery_aoe")
	table.insert(cfg.plistdps,"Carve_aoe")
	table.insert(cfg.plistdps,"Flanking Strike")
	table.insert(cfg.plistdps,"Spitting Cobra")
	table.insert(cfg.plistdps,"Throwing Axes")
	table.insert(cfg.plistdps,"Caltrops")
	table.insert(cfg.plistdps,"Raptor Strike_nomax")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"end")
	cfg.plistaoe = nil
	
	cfg.plist = cfg.plistdps

	cfg.case = {
		["Hatchet Toss"] = function()
			if lib.inrange("Mongoose Bite") then return nil end
			if lib.inrange("Hatchet Toss") then
				return lib.SimpleCDCheck("Hatchet Toss")
			end
			return nil
		end,
		["Harpoon"] = function()
			if lib.inrange("Mongoose Bite") then return nil end
			if lib.inrange("Harpoon") then
				return lib.SimpleCDCheck("Harpoon")
			end
			return nil
		end,
		--[[["Flanking Strike"] = function()
			return lib.SimpleCDCheck("Flanking Strike",lib.Time2Power(cfg.Power.max-10))
		end,]]
		["Flanking Strike"] = function()
			return lib.SimpleCDCheck("Flanking Strike",lib.Time2Power(85))
		end,
		["Lacerate"] = function()
			return lib.SimpleCDCheck("Lacerate",lib.GetAura({"Lacerate"})-3.6)
		end,
		["Caltrops"] = function()
			return lib.SimpleCDCheck("Caltrops",lib.GetAura({"Caltrops"})-1.8)
		end,
		["Raptor Strike_nomax"] = function()
			return lib.SimpleCDCheck("Raptor Strike",lib.Time2Power(cfg.Power.max))
		end,
		["Raptor Strike_buff"] = function()
			if lib.GetAuraStacks("Mok'Nathal Tactics")<4 then
				return lib.SimpleCDCheck("Raptor Strike",lib.GetAura({"Mongoose Fury"}))
			else
				return lib.SimpleCDCheck("Raptor Strike",lib.GetAura({"Mok'Nathal Tactics"})-2.4)
			end
		end,
		["Raptor Strike_debuff"] = function()
			if cfg.cleaving>=2 and not cfg.noaoe then
				return lib.SimpleCDCheck("Carve",lib.GetAura({"Serpent Sting"})-4.5)
			end
			return lib.SimpleCDCheck("Raptor Strike",lib.GetAura({"Serpent Sting"})-4.5)
		end,
		["Mongoose Bite_max"] = function()
			return lib.SimpleCDCheck("Mongoose Bite",lib.GetSpellCD("Mongoose Bite",nil,lib.GetSpellMaxCharges("Mongoose Bite"))-(lib.GetSpellMaxCharges("Mongoose Bite")-1)*cfg.gcd)
		end,
		["Snake Hunter"] = function()
			if lib.GetSpellCharges("Mongoose Bite")==0 and lib.GetAura({"Mongoose Fury"})>lib.GetSpellCD("Snake Hunter")+4*cfg.gcd then
				return lib.SimpleCDCheck("Snake Hunter") --,lib.GetAura({"Aspect of the Eagle"})
			end
			return nil
		end,
		["Aspect of the Eagle"] = function()
			if lib.GetSpellCharges("Mongoose Bite")<lib.GetSpellMaxCharges("Mongoose Bite") and lib.GetAura({"Mongoose Fury"})>lib.GetSpellCD("Aspect of the Eagle")+3*cfg.gcd then
				return lib.SimpleCDCheck("Aspect of the Eagle",lib.GetAura({"Aspect of the Eagle"}))
			end
			return nil
		end,
		["Mongoose Bite_Mongoose Fury"] = function()
			if lib.GetAura({"Mongoose Fury"})>lib.GetSpellCD("Mongoose Bite") then
				return lib.SimpleCDCheck("Mongoose Bite")
			end
			return nil
		end,
		["Fury of the Eagle"] = function()
			if lib.GetAura({"Mongoose Fury"})>lib.GetSpellCD("Fury of the Eagle") then
				return lib.SimpleCDCheck("Fury of the Eagle")
			end
			return nil
		end,
		["Carve_aoe"] = function()
			if cfg.cleaving>=4 then
				return lib.SimpleCDCheck("Carve") --,lib.Time2Power(75)
			end
			return nil
		end,
		["Butchery_aoe"] = function()
			if cfg.cleaving>=2 then
				return lib.SimpleCDCheck("Butchery") --,lib.Time2Power(85)
			end
			return nil
		end,
	}
	
	lib.AddRangeCheck({
	{"Mongoose Bite",nil},
	{"Hatchet Toss",{0,0,1,1}},
	{"Harpoon",{1,1,0,1}},
	})
	--cfg.mode = "dps"
	
	--cfg.spells_aoe={"MS"}
	--cfg.spells_single={"AS"}
	
	return true
end

lib.classpostload["HUNTER"] = function()
	--lib.SetPower(cfg.Power.type)
	lib.AddSpell("Mend",{136}) -- Mend Pet
	lib.AddAura("Mend",136,"buff","pet") -- Mend Pet
	cfg.case["Mend_pet"] = function()
		if cfg.GUID["pet"]~=0 and lib.GetUnitHealth("pet")<90 then
			return lib.SimpleCDCheck("Mend",lib.GetAura({"Mend"})-3)
		end
		return nil
	end
	
	lib.SetInterrupt("Kick",{147362,187707})
	
	cfg.onpower=true
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("CS")
		lib.CDadd("Tranq")
		lib.CDadd("Mend")
		lib.CDadd("MD")
		lib.CDtoggleOff("MD")
		
		lib.CDadd("Fury of the Eagle")
		lib.CDadd("Trueshot")
		lib.CDadd("Aspect of the Eagle")
		lib.CDadd("Snake Hunter")
		lib.CDadd("A Murder of Crows")
		lib.CDadd("Spitting Cobra")
		lib.CDadd("Steel Trap")
		lib.CDadd("Raptor Strike")
		lib.CDadd("Caltrops")
		lib.CDadd("Harpoon")
		lib.CDadd("Hatchet Toss")
		lib.CDadd("Stampede")
		lib.CDaddTimers("Stampede","Stampede",function(self, event, unitID,spellname, rank, castid, spellID)
			if event=="UNIT_SPELLCAST_SUCCEEDED" and unitID=="player" and spellID==lib.GetSpellId("Stampede") then
				CooldownFrame_SetTimer(self.cooldown,GetTime(),40,1)
			end
		end
		,{"UNIT_SPELLCAST_SUCCEEDED"})
		lib.CDadd("FF")
		lib.CDadd("RF")
		lib.CDadd("BW")
		lib.CDadd("DB")
		lib.CDaddTimers("DB","DB",function(self, event, unitID,spellname, rank, castid, spellID)
			if event=="UNIT_SPELLCAST_SUCCEEDED" and unitID=="player" and spellID==lib.GetSpellId("DB") then
				CooldownFrame_SetTimer(self.cooldown,GetTime(),15,1)
			end
		end
		,{"UNIT_SPELLCAST_SUCCEEDED"})
		lib.CDadd("Barrage")
		lib.CDadd("GT")
		lib.CDadd("Powershot")
		lib.CDadd("Crows")
		lib.CDAddCleave("Carve")
		lib.CDAddCleave("Butchery")
		lib.CDAddCleave("Explosive Trap",nil,13812)
		--lib.CDAddCleave("Dragonsfire Grenade",nil,194859)
	end
end
end